"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AprilShipStatus = void 0;
const Enums_1 = require("../../constant/Enums");
const ShipStatus_1 = require("./ShipStatus");
const AutoDoorsSystem_1 = require("../systems/AutoDoorsSystem");
const HudOverrideSystem_1 = require("../systems/HudOverrideSystem");
const LifeSuppSystem_1 = require("../systems/LifeSuppSystem");
const MedScanSystem_1 = require("../systems/MedScanSystem");
const ReactorSystem_1 = require("../systems/ReactorSystem");
const SabotageSystem_1 = require("../systems/SabotageSystem");
const SecurityCameraSystem_1 = require("../systems/SecurityCameraSystem");
const SwitchSystem_1 = require("../systems/SwitchSystem");
class AprilShipStatus extends ShipStatus_1.ShipStatus {
    constructor(netid, data) {
        super(netid, data);
        this.classname = "ShipStatus";
    }
    Deserialize(reader, spawn = false) {
        if (!this.systems) {
            this.systems = {
                [Enums_1.SystemType.Reactor]: new ReactorSystem_1.ReactorSystem,
                [Enums_1.SystemType.Electrical]: new SwitchSystem_1.SwitchSystem,
                [Enums_1.SystemType.O2]: new LifeSuppSystem_1.LifeSuppSystem,
                [Enums_1.SystemType.MedBay]: new MedScanSystem_1.MedScanSystem,
                [Enums_1.SystemType.Security]: new SecurityCameraSystem_1.SecurityCameraSystem,
                [Enums_1.SystemType.Communications]: new HudOverrideSystem_1.HudOverrideSystem,
                [Enums_1.SystemType.Doors]: new AutoDoorsSystem_1.AutoDoorsSystem,
                [Enums_1.SystemType.Sabotage]: new SabotageSystem_1.SabotageSystem
            };
        }
        this.DeserializeStep2(reader, spawn);
    }
}
exports.AprilShipStatus = AprilShipStatus;
AprilShipStatus.classname = "ShipStatus";
